#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "sonic.h"
#pragma pack(1)
#define BUFSAMPLES 11025 //0.5S at 22k
float GetSpeed();
HINSTANCE hLThis = 0;
HINSTANCE hL = 0;
FARPROC p[12] = {0};
sonicStream stream;
typedef int (__stdcall *procallback)(short *, int);
//The original ProTALKER callback that we're going to modify
procallback origproc;
int __stdcall mycallback(void *buffer, int numbytes);
short outbuf[BUFSAMPLES];
float boost=1.0;
bool usereg=true; //use the registry or not, for NVDA driver

BOOL WINAPI DllMain(HINSTANCE hInst,DWORD reason,LPVOID)
	{
	if (reason == DLL_PROCESS_ATTACH)
		{
		stream = sonicCreateStream(22050, 1);
		hLThis = hInst;
		char buf[MAX_PATH+1];
		GetModuleFileName(hInst, buf, MAX_PATH);
		char *sep = strrchr(buf, '\\')+1;
		*sep = '\0';
		int remaining = (buf+MAX_PATH)-sep;
strncat(sep, "tts_mgr2.dll", remaining);
		hL = LoadLibrary(buf);
		if (!hL) return false;


		p[0] = GetProcAddress(hL,"SynSpeak");
		p[1] = GetProcAddress(hL,"spcSynCntl");
		p[2] = GetProcAddress(hL,"spcSynFlush");
		p[3] = GetProcAddress(hL,"spcSynInit");
		p[4] = GetProcAddress(hL,"spcSynPause");
		p[5] = GetProcAddress(hL,"spcSynReadStat");
		p[6] = GetProcAddress(hL,"spcSynRepeat");
		p[7] = GetProcAddress(hL,"spcSynResume");
		p[8] = GetProcAddress(hL,"spcSynSelDev");
		p[9] = GetProcAddress(hL,"spcSynSpeak");
		p[10] = GetProcAddress(hL,"spcSynSpeakEx");
		p[11] = GetProcAddress(hL,"spcSynTerm");


		}
	if (reason == DLL_PROCESS_DETACH)
		{
		FreeLibrary(hL);
		}

	return 1;
	}

// SynSpeak
extern "C" __declspec(naked) void __stdcall __E__0__()
	{
	__asm
		{
		jmp p[0*4];
		}
	}
struct params {
int rate;
int pitch;
int i3;
int accent;
int font;
int unknown2;
WORD off20;
};
// spcSynCntl
extern "C"  int __stdcall __E__1__(int handle, struct params *pa)
	{
typedef int (__stdcall *pS)(int, struct params *);
pS orig = (pS )p[1];
return orig(handle, pa);
	}

// spcSynFlush
extern "C" __declspec(naked) void __stdcall __E__2__()
	{
	__asm
		{
		jmp p[2*4];
		}
	}

// spcSynInit
extern "C" __declspec(naked) void __stdcall __E__3__()
	{
	__asm
		{
		jmp p[3*4];
		}
	}

// spcSynPause
extern "C" __declspec(naked) void __stdcall __E__4__()
	{
	__asm
		{
		jmp p[4*4];
		}
	}

// spcSynReadStat
extern "C" __declspec(naked) void __stdcall __E__5__()
	{
	__asm
		{
		jmp p[5*4];
		}
	}

// spcSynRepeat
extern "C" __declspec(naked) void __stdcall __E__6__()
	{
	__asm
		{
		jmp p[6*4];
		}
	}

// spcSynResume
extern "C" __declspec(naked) void __stdcall __E__7__()
	{
	__asm
		{
		jmp p[7*4];
		}
	}

// spcSynSelDev
extern "C" __declspec(naked) void __stdcall __E__8__()
	{
	__asm
		{
		jmp p[8*4];
		}
	}

// spcSynSpeak
extern "C" int __stdcall __E__9__(int handle, char *s, int useless, int useless2, int size, procallback proc)
	{
int nsamples, retval;
typedef int (__stdcall *of)(int, char *, int, int, int, void *);
of orig = (of)p[9];
origproc = proc;
//speak our text
sonicSetSpeed(stream, GetSpeed());
retval = orig(handle, s, useless, useless2, size, mycallback);
//call the original callback one more time, because we may still have a few more bytes left.
sonicFlushStream(stream);
nsamples = sonicReadShortFromStream(stream, outbuf, BUFSAMPLES);
if (nsamples > 0) {
origproc(outbuf, nsamples*2);
}
return retval;
/*
	__asm
		{
		jmp p[9*4];
		}
*/
	}

// spcSynSpeakEx
extern "C" __declspec(naked) void __stdcall __E__10__()
	{
	__asm
		{
		//jmp p[10*4];
		}
	}

// spcSynTerm
extern "C" __declspec(naked) void __stdcall __E__11__()
	{
	__asm
		{
		jmp p[11*4];
		}
	}

int __stdcall mycallback(void *buffer, int numbytes)
{
//we're called with an already filled buffer of sound.
int nsamples;
sonicWriteShortToStream(stream, (short *)buffer, numbytes/2);
nsamples = sonicReadShortFromStream(stream, outbuf, BUFSAMPLES);
if (nsamples > 0) {
//Call our original callback with the new data
return origproc(outbuf, nsamples*2);
}
return 1;
}

//Try to get the speed from the registry. If it fails, return 1.0.
float GetSpeed()
{
HKEY key;
DWORD speed=100, size=4;
float newspeed=1.0;
if (!usereg) {
return boost;
}
if (RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\IBM\\ProTALKER", 0, KEY_READ, &key) != ERROR_SUCCESS)
return newspeed;
if ((RegQueryValueEx(key, "speed", NULL, NULL, (LPBYTE)&speed, &size)) == ERROR_SUCCESS) {
//If we create the speed while we're using the synth, speed will be 0.
if (speed == 0) speed = 100;
newspeed = speed/100.0;
}
return newspeed;
}
void __stdcall setboost(float speed)
{
boost = speed;
usereg = false;
}
